import java.math.BigDecimal;

public interface Encapsulation
{
 public void setNameVal(String name,String value);
 public void setNameVal(String name,int value);
 public void setNameVal(String name,long value);
 public void setNameVal(String name,float value);
 public void setNameVal(String name,double value);
 public void setNameVal(String name,double value,boolean dec);
 public void setTable(String table);
 public void setName(String name);
 public void setCondition(String cond);
 public void setValue(int value);
 public void setValue(long value);
 public void setValue(float value);
 public void setValue(double value);
 public void setValue(String value);
 public void setDecValue(double value);

 public int getType(int pos);
 public int getSize();
 public int getValueSize();
 public long getLongValue(int pos);
 public int getIntLongValue(int pos);
 public double getDecDoubleValue(int pos);
 public BigDecimal getDecValue(int pos);
 public String getValue(int pos);
 public int getIntValue(int pos);
 public float getFloatValue(int pos);
 public double getDoubleValue(int pos);
 public String getStringValue(int pos);
 public String extractAll(String name);
 public double extractDouble(String name);
 public float extractFloat(String name);
 public String extractString(String name,String value);
 public int extractInteger(String name,int value);
 public String extractName(String value);
 public String getName(int pos);
 public String getTable();
 public int getPosition(String name);
}
